//
// rauch.h
//

void RauchInsert ( short x, short y )
{
  short i;

  RauchAnz++;
  if ( RauchAnz >= RAUCHMAX ) { RauchAnz--; return; }

  memset(&Rauch[RauchNextFree], 0, sizeof(RAUCH));

  Rauch[RauchNextFree].free         = 1;
  Rauch[RauchNextFree].x            = x;
  Rauch[RauchNextFree].y            = y;
  Rauch[RauchNextFree].index        = 0;

  for(i=RauchNextFree; i<RAUCHMAX; ++i) if ( !Rauch[i].free ) { RauchNextFree = i; return; }
}


void RauchDelete ( short index )
{
  RauchAnz--;
  Rauch[index].free = 0;

  if ( index < RauchNextFree ) RauchNextFree = index;
}

void ShowRauch ( short index )
{
  static short i, j, k;

  k = Rauch[index].index*196;

  for(i=0; i<14; i++)
  {
    for(j=0; j<14; j++)
    {
      if ( RauchData[k] != 0 ) ssetpix(Rauch[index].x+j, Rauch[index].y+i, RauchData[k]);
      k++;
    }
  }
}

void RauchCompute ( short index )
{
  if ( GameDel >= GameSpeed ) Rauch[index].index++;
  if ( Rauch[index].index > 7 ) { RauchDelete(index); return; }

  ShowRauch(index);
}

